# BLUPF90 guided study

# LAB 2 - University of Florida, 2022 

#Daniela Lourenco | Natalia Leite 


#@dodo128
cd /home/natalia/blupf90-uf/lab2


#=========================================================================================================
#Ex 01-05

cd /home/natalia/blupf90-uf/lab2/ex1-4

#Ex01:
#copying files to our folder:

ln -s ../genotypes.txt  . #soft link for genotype file 
cp ../pedigree.txt .      #pedigree file 
cp ../phenotypes.txt .    #phenotypic file 
cp ../renum.par .         #parameter file 

***** TIP *********
# Creating soft links instead of making file copies will save server space (recommended) 
*******************

#Ex02:
#checking if all genotyped animals are phenotyped 

awk '{print $1}' pedigree.txt | sort +0 -1   > ped-sort.temp #ids of animals with pedigree 
awk '{print $1}' genotypes.txt | sort +0 -1   > gen-sort.temp #ids of genotyped animals 
join -v1  gen-sort.temp ped-sort.temp | wc -l  #number of animals with pedigree & genotyped: 2436
rm *.temp #removing temporary files from the folder 

#Ex03:

# Our main objective in this exercise is to do quality control with PREGSF90 
# For that, our first step is to run RENUMF90

#include the option to read genotype file on the parameter file in renum.par 
SNP_file 
genotypes.txt

# Running renumf90 and saving the log file
renumf90 renum.par | tee renum.log


# Some important statistics are given at the end of RENUMF90 log file:

 Pedigree checks

 Number of animals with records                  =         3534
 Number of animals with genotypes                =         2439
 Number of animals with records or genotypes     =         3537
 Number of animals with genotypes and no records =            3
 Number of parents without records or genotypes  =         2909
 Total number of animals                         =         6446


#Now, we are ready to run PREGSF90

#To save the clean file we need to add the OPTION:
OPTION saveCleanSNPs

#As we only want to do quality control we should avoid contructing any unnecessary relationship matrix
#We do that by adding those options:
OPTION createGInverse 0
OPTION createA22Inverse 0
OPTION createGimA22i 0


#Running PREGSF90 and saving clean files
preGSf90 renf90.par | tee pregs.log

***** TIP *********
#Read more about OPTIONS for PREGF90 here:
http://nce.ads.uga.edu/wiki/doku.php?id=readme.pregsf90
*******************

#Let's check PREGSF90 output:

#Quality control - For SNPS:


 Quality Control - SNPs with Call Rate < callrate ( 0.90) will removed: 63

 Quality Control - SNPs with MAF < minfreq ( 0.05) will removed: 7454

 Quality Control - Monomorphic SNPs will be removed: 10
 
#Quality control - For animals:

 Quality Control - Removed Animals with Call rate < callrate ( 0.90): 0
 
 Number of Parent-Progeny Mendelian Conflicts: 2
 
 
#  *****************************************
# *  Possible genotype duplicates samples *
# *****************************************

    i-j number of sample , i-j renumber Id, G(i,j), G(i,i), G(j,j), r(i,j)
         834     833    3535    2264  0.8985  0.8985  0.8985  1.0000
        1551    1550    3536     602  1.2024  1.2024  1.2024  1.0000
        2044    2043    3537     812  1.0351  1.0351  1.0351  1.0000
 

 Number of effective SNPs (after QC): 45336
 Number of SNPs: 52843

#Note that animals with mendelian conflits will be removed from clean files, BUT
#Duplicated genotypes are NOT REMOVED automatically - you should do this by yourself 

 Genotyped animals: 2439
 Number of effective Individuals (after QC): 2437



***** TIP *********
#How to remove duplicated animals from the clean files:

#Remember that this number 'i j number of sample' is the index (row number) of the sample and not the ID of the animals
#Checking the first pair of duplicated animals:
awk 'NR==834 {print $1}' genotypes.txt  #3372_dup 
awk 'NR==833 {print $1}' genotypes.txt

#you can choose to exclude the duplicated pair or only one animal per duplicated pair (if you are sure where the problem is)
#In this case, let's exclude only one animal from the duplicated pair (the ones labed 'dup')

#With the index of the duplicated samples we can exclude them and create a new SNP file
awk '{if(NR!=834 && NR!=1551 && NR!=2044) print $0}' genotypes.txt > genotypes_no_duplicate.txt 
 
#run RENUMF90/PREGSF90 again with the new genotype file without duplicated animals
*******************


#Ex04:

#Running BLUPF90 with clean files

#To run ssGBLUP using clean files we need to substitute this OPTION:
OPTION SNP_file genotypes.txt
#to 
OPTION SNP_file genotypes.txt_clean  #this file was generated by PREGSF90 
#The other OPTIONS (used in PREGSF90) can be removed from the parameter file!


#As quality control was already performed on PREGS90 (and we are using clean files) we can turn off quality control 
# using this option:

OPTION no_quality_control

#If you want to calculate ACC/REL you should add the option 'OPTION sol se' (as we saw in the previous lab)
OPTION sol se

#Now let's run BLUPF90 to get GEBV
blupf90 renf90.par | tee blup.log


#Check blupf90.log to see if all options are being used by the program:

 Options read from parameter file for genomic
 * SNP format: BLUPF90 standard (text)
 * SNP file: genotypes.txt_clean
 * SNP Xref file: genotypes.txt_clean_XrefID
 * No Quality Control Checks !!!!! (default .false.):  T


#The GEBV will be stored in the file 'solutions', and should contain SE in the last column 


#=========================================================================================================
#Ex 05-07

#Tricking BLUPF90 to run GBLUP

cd /home/natalia/blupf90-uf/lab2/ex5-7

ln -s ../ex2-5/genotypes.txt_clean  . #soft link for clean genotype file from our last exercise
cp ../pedigree.txt .      #pedigree file 
cp ../phenotypes.txt .    #phenotypic file 
cp ../renum.par .         #parameter file 

#Let's create a phenotypic file only for our genotyped animals
awk '{print $1}' genotypes.txt_clean | sort +0 -1 > id-gen.temp #id of genotyped animals 
sort +0 -1 phenotypes.txt > phen.temp #ids of phenotyped animals 
join id-gen.temp phen.temp > phenotypes-gen.txt #new phenotype file only for genotyped animals 
rm *.temp  #removing temporary files 
wc -l phenotypes-gen.txt phenotypes.txt  #checking if non genotyped animals were removed 

# Now let's edit our renum.par by remove pedigree file information
# Commenting or removing those lines work

#FILE
#pedigree.txt
#FILE_POS
#1 2 3 0 0

#remember to change the name of the genotype file - we want to use clean files!
#remember to change the name of the phenotype file - we want to use phenotypes only for genotyped animals 

#Rum RENUMF90 
renumf90 renum.par | tee renum.log

#Now let's add the required options for GBLUP into renf90.par 
OPTION AlphaBeta 0.95 0.05
OPTION tunedG 0
OPTION no_quality_control #We are using clean files

#Rum BLUPF90 
blupf90 renf90.par | tee blup.log


***** TIP *********
#Read a tutorial (step-by-step) on how to run GBLUP in BLUPF90 suit
https://masuday.github.io/blupf90_tutorial/genomic_gblup.html#:~:text=Background,seen%20in%20the%20previous%20chapters.
*******************



#=========================================================================================================
#Ex 08

#Note that at the end of this exercise we should compare results with exercise 6, which is a GBLUP model 
#Therefore we need to follow the same steps as before to run GBLUP with the exception that now we will 
#Save G with PREGSF90 and then use the saved G matrix in BLUPF90

cd /home/natalia/blupf90-uf/lab2/ex8

ln -s ../ex2-5/genotypes.txt_clean  . #soft link for clean genotype file from our last exercise
cp ../pedigree.txt .      #pedigree file 
cp ../phenotypes.txt .    #phenotypic file 
cp ../renum.par .         #parameter file 

#Let's create a phenotypic file only for our genotyped animals
awk '{print $1}' genotypes.txt_clean | sort +0 -1 > id-gen.temp
sort +0 -1 phenotypes.txt > phen.temp
join id-gen.temp phen.temp > phenotypes-gen.txt #new phenotype file for genotyped animals 
rm *.temp  #removing temporary files 
wc -l phenotypes-gen.txt phenotypes.txt  #checking if non genotyped animals were removed 

#Now let's edit our renum.par to remove pedigree file information

#FILE
#pedigree.txt
#FILE_POS
#1 2 3 0 0

#remember to change the name of the phenotype file - we want to use phenotypes only for genotyped animals 

#Rum RENUMF90 
renumf90 renum.par | tee renum.log

#remember to change the name of the genotype file - we want to use clean files!

#Now let's add the required options for GBLUP 
OPTION AlphaBeta 0.95 0.05
OPTION tunedG 0
OPTION no_quality_control #We are using clean files

#Now let's include the OPTION to save G in PREGSF90

***** TIP *********
#Read more about saving and reading options with PREGSF90 here:
http://nce.ads.uga.edu/wiki/doku.php?id=readme.pregsf90
*******************

OPTION saveG #saving G

preGSf90 renf90.par | tee pregs.log

#Now it is time for us to run BLUPF90
#let's add the option for reding the matrix G we just saved 

OPTION readG #saving G

blupf90 renf90.par | tee blup.log

#Now we can see that results from this exercise and exercise 6 are exactly the same!


#=========================================================================================================
#Ex 9

cd /home/natalia/blupf90-uf/lab2/ex9

ln -s ../ex2-5/genotypes.txt_clean  . #soft link for clean genotype file from our last exercise
cp ../pedigree.txt .      #pedigree file 
cp ../phenotypes.txt .    #phenotypic file 
cp ../renum.par .         #parameter file 


#Let's use the clean genotype file to run preGSf90 add the saving OPTIONS for A and G
#Change the name of the genotype file in renum.par to the name of the clean genotype file!

OPTION no_quality_control
OPTION saveAscii #Save files intermediate matrices (GimA22i,G,Gi,etc) files as ASCII (default=binary)
OPTION saveGInverse

renumf90 renum.par | tee renum.log

preGSf90 renf90.par | tee pregs.log

# G-1 matrix:
#row, column, value
1 1 2.363929766818
1 2 -.055115207501
2 2 2.578843466546
1 3 -.128792302643


#When you use an user file in blupf90, IDs in the covariance matrix should match IDs in the phenotype file
#Before running blupf90, you can change the IDs for the animals in the phenotype file using the following commands:

awk '{print $1,NR}' genotypes.txt_clean_XrefID | sort +0 -1 > index.gen
awk '{print $3,$0}' renf90.dat | sort +0 -1 > srenf90.temp
join -1 +1 -2 +1 srenf90.temp index.gen | awk '{print $2,$3,$5,$4}' | sort -n +2 -3 > srenf90.dat

#Now we need to modify the name of the date file in renf90.par to 'srenf90.dat'


#Now we need to add some lines to use G-1 (that was saved before) as a covariance matrix in renf90.par  

#The lines that should be added can be checked here:
http://nce.ads.uga.edu/wiki/doku.php?id=user_defined_files_for_covariances_of_random_effects

RANDOM_GROUP
 # genomic
 2
RANDOM_TYPE
user_file
FILE
 # matrix file
Gi

#Remove all the options we used before from the parameter file!

blupf90 renf90.par | tee blup.log

#Solutions with your user_file matrix will be in 'solutions'